diff --git a/gdb/f-lang.h b/gdb/f-lang.h
index 746c11fd9f..1ba529d76c 100644
--- a/gdb/f-lang.h
+++ b/gdb/f-lang.h
@@ -50,9 +50,9 @@ struct common_block
   struct symbol *contents[1];
 };
 
-extern int f77_get_upperbound (struct type *);
+extern LONGEST f77_get_upperbound (struct type *);
 
-extern int f77_get_lowerbound (struct type *);
+extern LONGEST f77_get_lowerbound (struct type *);
 
 extern void f77_get_dynamic_array_length (struct type *);
 
diff --git a/gdb/f-typeprint.c b/gdb/f-typeprint.c
index 2dfae5803c..a0e34b3058 100644
--- a/gdb/f-typeprint.c
+++ b/gdb/f-typeprint.c
@@ -161,8 +161,6 @@ f_type_print_varspec_suffix (struct type *type, struct ui_file *stream,
 			     int show, int passed_a_ptr, int demangled_args,
 			     int arrayprint_recurse_level)
 {
-  int upper_bound, lower_bound;
-
   /* No static variables are permitted as an error call may occur during
      execution of this function.  */
 
@@ -192,9 +190,10 @@ f_type_print_varspec_suffix (struct type *type, struct ui_file *stream,
             f_type_print_varspec_suffix (TYPE_TARGET_TYPE (type), stream, 0,
                                         0, 0, arrayprint_recurse_level);
 
-          lower_bound = f77_get_lowerbound (type);
+          LONGEST lower_bound = f77_get_lowerbound (type);
+
           if (lower_bound != 1)	/* Not the default.  */
-            fprintf_filtered (stream, "%d:", lower_bound);
+            fprintf_filtered (stream, "%s:", plongest (lower_bound));
 
           /* Make sure that, if we have an assumed size array, we
              print out a warning and print the upperbound as '*'.  */
@@ -203,8 +202,9 @@ f_type_print_varspec_suffix (struct type *type, struct ui_file *stream,
             fprintf_filtered (stream, "*");
           else
             {
-              upper_bound = f77_get_upperbound (type);
-              fprintf_filtered (stream, "%d", upper_bound);
+              LONGEST upper_bound = f77_get_upperbound (type);
+
+              fputs_filtered (plongest (upper_bound), stream);
             }
 
           if (TYPE_CODE (TYPE_TARGET_TYPE (type)) != TYPE_CODE_ARRAY)
@@ -273,7 +273,6 @@ void
 f_type_print_base (struct type *type, struct ui_file *stream, int show,
 		   int level)
 {
-  int upper_bound;
   int index;
 
   QUIT;
@@ -364,8 +363,9 @@ f_type_print_base (struct type *type, struct ui_file *stream, int show,
 	fprintfi_filtered (level, stream, "character*(*)");
       else
 	{
-	  upper_bound = f77_get_upperbound (type);
-	  fprintf_filtered (stream, "character*%d", upper_bound);
+	  LONGEST upper_bound = f77_get_upperbound (type);
+
+	  fprintf_filtered (stream, "character*%s", pulongest (upper_bound));
 	}
       break;
 
diff --git a/gdb/f-valprint.c b/gdb/f-valprint.c
index eee0a62fe8..5f9dd4dedb 100644
--- a/gdb/f-valprint.c
+++ b/gdb/f-valprint.c
@@ -41,7 +41,7 @@ int f77_array_offset_tbl[MAX_FORTRAN_DIMS + 1][2];
 /* Array which holds offsets to be applied to get a row's elements
    for a given array.  Array also holds the size of each subarray.  */
 
-int
+LONGEST
 f77_get_lowerbound (struct type *type)
 {
   if (TYPE_ARRAY_LOWER_BOUND_IS_UNDEFINED (type))
@@ -50,7 +50,7 @@ f77_get_lowerbound (struct type *type)
   return TYPE_ARRAY_LOWER_BOUND_VALUE (type);
 }
 
-int
+LONGEST
 f77_get_upperbound (struct type *type)
 {
   if (TYPE_ARRAY_UPPER_BOUND_IS_UNDEFINED (type))
diff --git a/gdb/testsuite/gdb.fortran/array-bounds.exp b/gdb/testsuite/gdb.fortran/array-bounds.exp
new file mode 100644
index 0000000000..e18530c75e
--- /dev/null
+++ b/gdb/testsuite/gdb.fortran/array-bounds.exp
@@ -0,0 +1,50 @@
+# Copyright 2012-2019 Free Software Foundation, Inc.
+
+# This program is free software; you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation; either version 3 of the License, or
+# (at your option) any later version.
+#
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+# GNU General Public License for more details.
+#
+# You should have received a copy of the GNU General Public License
+# along with this program.  If not, see <http://www.gnu.org/licenses/>.
+
+# This file is part of the gdb testsuite.  It contains test to ensure that
+# array bounds accept LONGEST.
+
+if { [skip_fortran_tests] } { return -1 }
+
+set testfile "array-bounds"
+standard_testfile .f90
+
+if {[prepare_for_testing $testfile.exp $testfile $srcfile {f90 debug}]} {
+    return -1
+}
+
+if {![runto MAIN__]} {
+    perror "Could not run to breakpoint `MAIN__'."
+    continue
+}
+
+# Convenience proc to setup for KFAIL
+proc kfail_if {exp bugid triplet} {
+    if {$exp} {
+	setup_kfail $bugid $triplet
+    }
+}
+
+# GCC outputs incorrect range debug info for -m32.
+set expect_fail false
+if {[is_ilp32_target] && ([istarget "i\[34567\]86-*-linux*"]
+			  || [istarget "x86_64-*-linux*"])} {
+    set expect_fail true
+}
+
+kfail_if $expect_fail "gcc/54934" "*-*-*"
+gdb_test "print &foo" {.*\(4294967296:4294967297\).*}
+kfail_if $expect_fail "gcc/54934" "*-*-*"
+gdb_test "print &bar" {.*\(-4294967297:-4294967296\).*}
diff --git a/gdb/testsuite/gdb.fortran/array-bounds.f90 b/gdb/testsuite/gdb.fortran/array-bounds.f90
new file mode 100644
index 0000000000..ec3c4691ac
--- /dev/null
+++ b/gdb/testsuite/gdb.fortran/array-bounds.f90
@@ -0,0 +1,26 @@
+! Copyright 2012-2019 Free Software Foundation, Inc.
+
+! This program is free software; you can redistribute it and/or modify
+! it under the terms of the GNU General Public License as published by
+! the Free Software Foundation; either version 3 of the License, or
+! (at your option) any later version.
+!
+! This program is distributed in the hope that it will be useful,
+! but WITHOUT ANY WARRANTY; without even the implied warranty of
+! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+! GNU General Public License for more details.
+!
+! You should have received a copy of the GNU General Public License
+! along with this program.  If not, see <http://www.gnu.org/licenses/>.
+
+      dimension foo(4294967296_8:4294967297_8)
+      dimension bar(-4294967297_8:-4294967296_8)
+      integer(8) :: lb, ub
+      bar = 42
+      foo = bar
+      lb = lbound (foo, dim = 1, kind = 8)
+      ub = ubound (foo, dim = 1, kind = 8)
+      print *, 'bounds of foo - ', lb, ':', ub
+      stop
+      end
+